extern crate reqwest;
extern crate select;

use select::document::Document;
use select::predicate::Name;

fn main() {
    scrape_feats("http://www.archivesofnethys.com/Feats.aspx?Category=Combat");
}


fn scrape_feats(url: &str) {
    // let bookstrs = [
    //     "ACG",
    //     "APG",
    //     "ARG",
    //     "ISWG",
    //     "OA",
    //     "UC",
    //     "UI",
    //     "(see the Pathfinder RPG Advanced Player's Guide)"
    // ];

    // commenting out -- going local for a bit
    let resp = reqwest::get(url).unwrap();
    assert!(resp.status().is_success());

    let doc = Document::from_read(resp).unwrap();

    //let doc = Document::from(include_str!("/home/jmelesky/code/featscraper/assets/feats.html"));

    // compile this regex once, not once per node
    let re_uppers = Regex::new(r"[A-Z]{2}").unwrap();

    let mut header = true;
    for node in doc.find(Name("tr")) {
        // skip the first one
        if header {
            header = false;
        } else {
            let mut tds = node.find(Name("td"));

            let link = tds.next().unwrap() // link table cell
                .find(Name("a")) // list of all links (just one)
                .next().unwrap(); // the first link
            let mut prereqs = tds.next().unwrap().text();

            // parse out the link and name
            let featurl = link.attr("href").unwrap();
            let mut featname = link.text();


            // extra code because '....unwrap().text().trim()' complains
            // about lifetime of borrowd value
            let featname = featname.trim();
            let prereqs = prereqs.trim();


            // print only the ones with two consecutive uppercase letters
            // in the prereqs -- figure out what to trim
            if re_uppers.is_match(prereqs) {
                println!("|{}|{}|{}|", featname, prereqs, featurl);
            }
        }
    }


}



